unit uImageProcessing;

interface

uses
	Windows, Graphics, PNGImage{ TPNGObject }, nStretchf;

function Saturate( X: Integer ): Byte;
procedure MakeAlphaCelcedBMP( DestBMP: TBitmap; DestX, DestY, DestWidth, DestHeight: Integer; SrcBMP: TBitmap; SrcX, SrcY: Integer; const AlphaRev: Boolean = False );
procedure CompleteAssign( const Dest: TBitmap; const Source: TPNGObject );
function Resize32BitBitmap( const Source: TBitmap; const NewSize: Double ): TBitmap;

implementation

function Saturate( X: Integer ): Byte;
asm
	test eax, eax
	jl @LESS //TCtOĂȂ
	CMP EAX, $FF
	jg @GREAT
	ret
	@LESS:
		mov al, 0
		ret
	@GREAT:
		mov al, 255
		ret
end;

function AdjustSize(
	var DestX, DestY, DestWidth, DestHeight: Integer;
	const DestBMPWidth, DestBMPHeight: Integer;
	var SrcX, SrcY: Integer;
	const SrcBMPWidth, SrcBMPHeight: Integer
	): Boolean;
begin

	//\[Xʒu}CiXwĂ
	if SrcX < 0 then begin
		Dec( DestX, SrcX );
		SrcX := 0;
	end;
	if SrcY < 0 then begin
		Dec( DestY, SrcY );
		SrcY := 0;
	end;
	//`ʈʒu}CiXwĂ
	if DestX < 0 then begin
		Dec( SrcX, DestX );
//		Inc( DestWidth, DestX );
		DestX := 0;
	end;
	if DestY < 0 then begin
		Dec( SrcY, DestY );
//		Inc( DestHeight, DestY );
		DestY := 0;
	end;
	//\[Xʒu傫͈͂`Ƃ
	if SrcX + DestWidth > SrcBMPWidth then begin
		if SrcX > SrcBMPWidth then //`ʊJnʒuO
			DestWidth := 0
		else
			DestWidth := SrcBMPWidth - SrcX;
	end;
	if SrcY + DestHeight > SrcBMPHeight then begin
		if SrcY > SrcBMPHeight  then
			DestHeight := 0
		else
			DestHeight := SrcBMPHeight - SrcY;
	end;
	//`ʈʒu傫
	if DestX + DestWidth > DestBMPWidth then begin
		if DestX > DestBMPWidth then //`ʊJnʒuO
			DestWidth := 0
		else
			Dec( DestWidth, DestX + DestWidth - DestBMPWidth );
	end;
	if DestY + DestHeight > DestBMPHeight then begin
		if DestY > DestBMPHeight then //`ʊJnʒuO
			DestHeight := 0
		else
			Dec( DestHeight, DestY + DestHeight - DestBMPHeight );
	end;
	Result := ( DestWidth = 0 )or( DestHeight = 0 );
end;

procedure MakeAlphaCelcedBMP( DestBMP: TBitmap; DestX, DestY, DestWidth, DestHeight: Integer; SrcBMP: TBitmap; SrcX, SrcY: Integer; const AlphaRev: Boolean = False );
var
	i: Integer;
	p, p2: pbytearray;
	d_StartX, s_StartX: Integer;
	f: Byte;
begin
	if ( DestBMP.PixelFormat <> pf32Bit )or( SrcBMP.PixelFormat <> pf32Bit ) then Exit;

	if AdjustSize( DestX, DestY, DestWidth, DestHeight, DestBMP.Width, DestBMP.Height, SrcX, SrcY, SrcBMP.Width, SrcBMP.Height ) then Exit;

	s_StartX:=(SrcX*4)+3;
	d_StartX:=DestX*4;
	if AlphaRev then f := 255 else f:=0;
	for i := DestY to DestY+DestHeight-1 do begin
		p := SrcBMP.ScanLine[i-DestY+SrcY];
		p := @(p[s_StartX]);
		p2 := DestBMP.ScanLine[i];
		p2 := @(p2[d_StartX]);

		asm
			push esi
			push edi

			mov esi, p
			mov edi, p2
			mov ch, f
			push DestWidth
			@LOOP_X:
				//x
				mov cl, [esi]
				xor cl, ch

				mov al, [edi]
				mul cl
				mov [edi], ah
				inc edi

				mov al, [edi]
				mul cl
				mov [edi], ah
				inc edi

				mov al, [edi]
				mul cl
				mov [edi], ah
				inc edi

				mov [edi], cl
				inc edi

				add esi, 4
			dec [esp]
			jnz @LOOP_X
			pop eax

			pop edi
			pop esi
		end;
	end;

	DestBMP.Modified := True;
end;

procedure CompleteAssign( const Dest: TBitmap; const Source: TPNGObject );
var
	sp, dp: PByte;
    x, y: Cardinal;
begin
	Dest.Assign( Source );
    if Source.TransparencyMode <> ptmNone then begin
    	Dest.PixelFormat := pf32Bit;

        for y := 0 to Source.Height-1 do begin
        	sp := Pointer( Source.AlphaScanline[y] );
            dp := Dest.ScanLine[y];
            Inc( dp, 3 );
            for x := 0 to Source.Width-1 do begin
            	dp^ := sp^;
                Inc( sp );
                Inc( dp, 4 );
            end;
        end;
    end;
end;

function Resize32BitBitmap( const Source: TBitmap; const NewSize: Double ): TBitmap;
var
	newW, newH: Integer;
    x, y: Integer;
    sp, dp: PByte;
    tmp: TBitmap;
begin
	newW := Round( Source.Width * NewSize );
    newH := Round( Source.Height * NewSize );

    tmp := TBitmap.Create();
    try
    	Result := TBitmap.Create();
        Result.Assign( Source );

        if Source.PixelFormat = pf32Bit then begin
        	tmp.PixelFormat := pf24Bit;
            tmp.Width := Source.Width;
            tmp.Height := Source.Height;
        	for y := 0 to Source.Height-1 do begin
            	sp := Source.ScanLine[y];
                Inc( sp, 3 );
                dp := tmp.ScanLine[y];
                for x := 0 to Source.Width-1 do begin
                	dp^ := sp^;
                    Inc( sp, 4 );
                    Inc( dp, 3 );
                end;
            end;

            Stretch( tmp, newW, newH );
			Stretch( Result, newW, newH );
            Result.PixelFormat := pf32Bit;
        	for y := 0 to Result.Height-1 do begin
            	sp := tmp.ScanLine[y];
                dp := Result.ScanLine[y];
                Inc( dp, 3 );
                for x := 0 to Result.Width-1 do begin
                	dp^ := sp^;
                    Inc( sp, 3 );
                    Inc( dp, 4 );
                end;
            end;
        end;
    finally
    	tmp.Free;
    end;
end;

end.
