unit uResizeSurface;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, uImageProcessing, PNGImage;

type
  TResizeSurface = class(TForm)
    TrackBar1: TTrackBar;
    Zoom: TLabel;
    Preview: TPaintBox;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PreviewPaint(Sender: TObject);
  private
    { Private 錾 }
  public
  	Orig: TBitmap;
    { Public 錾 }
  end;

var
  ResizeSurface: TResizeSurface;

implementation

{$R *.dfm}

procedure TResizeSurface.TrackBar1Change(Sender: TObject);
begin
	Preview.Invalidate();
    Zoom.Caption := '\{: '+FormatFloat( '0.00', TrackBar1.Position/100 );
end;

procedure TResizeSurface.FormCreate(Sender: TObject);
var
	png: TPNGObject;
begin
	Orig := TBitmap.Create();

	png := TPNGObject.Create();
    try
    	png.LoadFromFile('imo.png');
        CompleteAssign( Orig, png );
    finally
    	png.Free;
    end;
	SetStretchBltMode( Preview.Canvas.Handle, HALFTONE );
    DoubleBuffered := True;
end;

procedure TResizeSurface.FormDestroy(Sender: TObject);
begin
	Orig.Free;
end;

procedure TResizeSurface.PreviewPaint(Sender: TObject);
begin
	StretchBlt( Preview.Canvas.Handle, 0, 0, Round( TrackBar1.Position/100*Orig.Width ), Round( TrackBar1.Position/100*Orig.Height ), Orig.Canvas.Handle, 0, 0, Orig.Width, Orig.Height, SRCCOPY );
end;

end.
