unit uScriptEngine;

interface

uses
	Windows, SysUtils, Classes, uActionBase, psvActiveScript { TpsvActiveScriptSite }, uSisterHEART;

type
	TASAction = class( TInterfacedObject, ISisterAction )
    private
    	FEngine: TpsvActiveScriptSite;
        FLangs: TStringList;
        FScriptList: TStringList;
    public
    	constructor Create();
        destructor Destroy(); override;
    	procedure Execute(); safecall;
    end;

implementation

{ TASAction }

constructor TASAction.Create;
var
	sr: TSearchRec;
    i: Integer;
begin
	inherited Create();

    FLangs := TStringList.Create();
    FLangs.LoadFromFile( 'ASLangs.txt' ); //{͐΃pXœnׂ
    for i := 0 to FLangs.Count-1 do
    	FLangs[i] := LowerCase( FLangs.Names[i] ) + '=' + FLangs.Values[ FLangs.Names[i] ];

    FScriptList := TStringList.Create();

    if FindFirst( 'AS\*.*', faAnyFile, sr ) = 0 then begin
    	repeat
        	if FLangs.IndexOfName( LowerCase( Copy( ExtractFileExt( sr.Name ), 2, Length( sr.Name ) ) ) ) <> -1 then
        		FScriptList.Add( 'AS\'+sr.Name );
		until FindNext(sr) <> 0;
		FindClose(sr);
    end;

    FEngine := TpsvActiveScriptSite.Create( nil );
end;

destructor TASAction.Destroy;
begin
	FEngine.Free;
    FScriptList.Free;
    FLangs.Free;

	inherited;
end;

procedure TASAction.Execute(); safecall;
var
	sl: TStringList;
    f: string;
begin
	if FScriptList.Count = 0 then Exit;

    sl := TStringList.Create();
    try
    	f := FScriptList[ Random( FScriptList.Count ) ];
    	sl.LoadFromFile( f );
        FEngine.ScriptLanguage := FLangs.Values[ LowerCase( Copy( ExtractFileExt( f ), 2, Length( f )-1 ) ) ];
        FEngine.Execute( sl.Text );
        try
        	FEngine.ScriptInterface.Execute( SisterHEARTIntf );
        except
        end;
    finally
    	sl.Free;
    end;
end;

end.
