unit uSisterHEART;

//CORE

interface

uses
	Windows, Variants, ActiveX, uDispatchImpl;

type
	ISisterHEART = interface(IDispatch)['{5DB03B2B-13BF-4A5C-A180-F2F2AD4542B8}']
    	procedure Say( const Message: WideString ); safecall;
    end;

    TSisterHEART_SayCommand = procedure ( const Message: WideString ) of object;
    TSisterHEART = class( TSmartDispatchImpl, ISisterHEART )
    private
    	FSayCommand: TSisterHEART_SayCommand;
    protected
		function SayDisp( DispID: Integer; const Flags: Word; Params: POleVariantArray; Argc: Integer; var VarResult, ExcepInfo, ArgErr: OleVariant ): HResult;
    public
		constructor Create();
    	procedure Say( const Message: WideString ); safecall;
    	property SayCommand: TSisterHEART_SayCommand read FSayCommand write FSayCommand;
    end;

var
  	SisterHEART: TSisterHEART;
    SisterHEARTIntf: ISisterHEART;

implementation

{ TSisterHEART }

constructor TSisterHEART.Create;
begin
	inherited Create();

    AddFunction( 'Say', DISPATCH_METHOD, SayDisp );
end;

procedure TSisterHEART.Say(const Message: WideString);
begin
	if Assigned( FSayCommand ) then FSayCommand( Message );
end;

function TSisterHEART.SayDisp(DispID: Integer; const Flags: Word;
  Params: POleVariantArray; Argc: Integer; var VarResult, ExcepInfo,
  ArgErr: OleVariant): HResult;
	procedure Get();
	begin
    	Say( Params[0] );
		VarResult := TRUE;
	end;
begin
	try
		if ( Flags and DISPATCH_METHOD ) = DISPATCH_METHOD then begin
			if Argc <> 1 then begin
				Result := DISP_E_BADPARAMCOUNT;
				Exit;
			end else
				Get();
			Result := S_OK;
        end else
        	Result := DISP_E_BADCALLEE;
	except
		Result := DISP_E_BADVARTYPE;
	end;
end;

initialization
	SisterHEART := TSisterHEART.Create();
    SisterHEARTIntf := SisterHEART;

end.
